#ifndef MRK_PARSER
#define MRK_PARSER

#include "mrk/ast.h"
#include "mrk/common.h"
#include "mrk/lexer.h"

#define MRK_MAX_HEADER_LEN 6

typedef struct mrk_parser mrk_parser;

/**
 * Initialize a new parser struct.
 */
mrk_err mrk_parser_init(mrk_parser **out);

void mrk_parser_open(mrk_parser *parser, mrk_lexer *lexer);

mrk_err mrk_parser_parse(mrk_ast_node **out, mrk_parser *parser);

#endif
